Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CanonVRD.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CanonVRD.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/CanonVRD.pm	(revision 34921)
@@ -1055,12 +1674,220 @@
 sub ProcessIHLExif($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
-    $$exifTool{DOC_NUM} = 1;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $$et{DOC_NUM} = 1;
     # the IHL-edited maker notes may look messed up, but the offsets should be OK
-    my $oldFix = $exifTool->Options(FixBase => 0);
-    my $rtnVal = $exifTool->ProcessTIFF($dirInfo, $tagTablePtr);
-    $exifTool->Options(FixBase => $oldFix);
-    delete $$exifTool{DOC_NUM};
+    my $oldFix = $et->Options(FixBase => 0);
+    my $rtnVal = $et->ProcessTIFF($dirInfo, $tagTablePtr);
+    $et->Options(FixBase => $oldFix);
+    delete $$et{DOC_NUM};
     return $rtnVal;
+}
+
+#------------------------------------------------------------------------------
+# Wrap DR4 data with the VRD header/footer and edit record
+# Inputs: 0) DR4 record
+# Returns: VRD[Edit[DR4]] data
+sub WrapDR4($)
+{
+    my $val = shift;
+    my $n = length $val;
+    my $oldOrder = GetByteOrder();
+    SetByteOrder('MM');
+    $val = $blankHeader . "\xff\xff\0\xf7" . Set32u($n+8) . Set32u($n) .
+                $val . "\0\0\0\0" . $blankFooter;
+    # update the new VRD length in the header/footer
+    Set32u($n + 16, \$val, 0x18);  # (extra 16 bytes for the edit record wrapper)
+    Set32u($n + 16, \$val, length($val) - 0x2c);
+    SetByteOrder($oldOrder);
+    return $val;
+}
+
+#------------------------------------------------------------------------------
+# Read/Write DPP version 4 edit data or DR4 file
+# Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
+# Returns:
+#   Reading from memory (not RAF and not IsWriting): 1 on success
+#   Editing from memory (not RAF and IsWriting): modified edit data, or undef if nothing changed
+#   Reading file (RAF and not OutFile): 1 if a valid DR4 file, 0 if not
+#   Writing file (RAF and OutFile): 1 if valid DR4 file, 0 if not, -1 on write error
+# (serves me right for not having a consistent interface for the various modes of operation)
+sub ProcessDR4($$;$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;    # allow dummy access
+    my $dataPt = $$dirInfo{DataPt};
+    my $raf = $$dirInfo{RAF};
+    my $outfile = $$dirInfo{OutFile};
+    my $isWriting = $outfile || $$dirInfo{IsWriting};
+    my $dataPos = $$dirInfo{DataPos} || 0;
+    my $verbose = $et->Options('Verbose');
+    my $unknown = $et->Options('Unknown');
+    my ($pos, $dirLen, $numEntries, $err, $newTags);
+
+    # write CanonDR4 as a block if specified
+    if ($isWriting) {
+        my $nvHash;
+        my $newVal = $et->GetNewValue('CanonDR4', \$nvHash);
+        if ($newVal) {
+            $et->VPrint(0, "  Writing CanonDR4 as a block\n");
+            $$et{DidCanonVRD} = 1;  # set flag so we don't add this twice
+            ++$$et{CHANGED};
+            if ($outfile) {
+                Write($$dirInfo{OutFile}, $newVal) or return -1;
+                return 1;
+            } else {
+                return $newVal;
+            }
+        } elsif (not $dataPt and ($nvHash or $$et{DEL_GROUP}{CanonVRD})) {
+            $et->Error("Can't delete all CanonDR4 information from a DR4 file");
+            return 1;
+        }
+    }
+    if ($dataPt) {
+        $pos = $$dirInfo{DirStart} || 0;
+        $dirLen = $$dirInfo{DirLen} || length($$dataPt) - $pos;
+    } else {
+        # load DR4 file into memory
+        my $buff;
+        $raf->Read($buff, 8) == 8 and $buff eq "IIII\x04\0\x04\0" or return 0;
+        $et->SetFileType();
+        $raf->Seek(0, 2) or return $err = 1;
+        $dirLen = $raf->Tell();
+        $raf->Seek(0, 0) or return $err = 1;
+        $raf->Read($buff, $dirLen) == $dirLen or $err = 1;
+        $err and $et->Warn('Error reading DR4 file'), return 1;
+        $tagTablePtr = GetTagTable('Image::ExifTool::CanonVRD::DR4');
+        $dataPt = \$buff;
+        $pos = 0;
+    }
+    my $dirEnd = $pos + $dirLen;
+
+    if (($$et{TAGS_FROM_FILE} and
+        not $$et{EXCL_TAG_LOOKUP}{canondr4}) or $$et{REQ_TAG_LOOKUP}{canondr4})
+    {
+        # extract CanonDR4 block if copying tags, or if requested
+        $et->FoundTag('CanonDR4', substr($$dataPt, $pos, $dirLen));
+    }
+
+    # version 4 header is 32 bytes (int32u[8])
+    if ($dirLen < 32) {
+        $err = 1;
+    } else {
+        SetByteOrder(substr($$dataPt, $pos, 2)) or $err = 1;
+        # process the DR4 header
+        my %hdrInfo = (
+            DataPt   => $dataPt,
+            DirStart => $pos,
+            DirLen   => 32,
+            DirName  => 'DR4Header',
+        );
+        my $hdrTable = GetTagTable('Image::ExifTool::CanonVRD::DR4Header');
+        if ($outfile) {
+            my $hdr = $et->WriteDirectory(\%hdrInfo, $hdrTable);
+            substr($$dataPt, $pos, 32) = $hdr if $hdr and length $hdr == 32;
+        } else {
+            $et->VerboseDir('DR4Header', undef, 32);
+            $et->ProcessDirectory(\%hdrInfo, $hdrTable);
+        }
+        # number of entries in the DR4 directory
+        $numEntries = Get32u($dataPt, $pos + 28);
+        $err = 1 if $dirLen < 36 + 28 * $numEntries;
+    }
+    $err and $et->Warn('Invalid DR4 directory'), return $outfile ? undef : 0;
+
+    if ($outfile) {
+        $newTags = $et->GetNewTagInfoHash($tagTablePtr);
+    } else {
+        $et->VerboseDir('DR4', $numEntries, $dirLen);
+    }
+
+    my $index;
+    for ($index=0; $index<$numEntries; ++$index) {
+        my ($val, @flg, $i);
+        my $entry = $pos + 36 + 28 * $index;
+        last if $entry + 28 > $dirEnd;
+        my $tag = Get32u($dataPt, $entry);
+        my $fmt = Get32u($dataPt, $entry + 4);
+        $flg[0] = Get32u($dataPt, $entry + 8);
+        $flg[1] = Get32u($dataPt, $entry + 12);
+        $flg[2] = Get32u($dataPt, $entry + 16);
+        my $off = Get32u($dataPt, $entry + 20) + $pos;
+        my $len = Get32u($dataPt, $entry + 24);
+        next if $off + $len >= $dirEnd;
+        my $format = $vrdFormat{$fmt};
+        if (not $format) {
+            $val = unpack 'H*', substr($$dataPt, $off, $len);
+            $format = 'undef';
+        } elsif ($format eq 'double' and $len == 8) {
+            # avoid teeny weeny values
+            $val = ReadValue($dataPt, $off, $format, undef, $len);
+            $val = 0 if abs($val) < 1e-100;
+        }
+        if ($outfile) {
+            # write (binary data) subdirectory if it exists
+            my $tagInfo = $et->GetTagInfo($tagTablePtr, $tag);
+            if ($tagInfo and $$tagInfo{SubDirectory}) {
+                my %subdirInfo = (
+                    DataPt   => $dataPt,
+                    DirStart => $off,
+                    DirLen   => $len,
+                    DirName  => $$tagInfo{Name},
+                );
+                my $subTablePtr = GetTagTable($$tagInfo{SubDirectory}{TagTable});
+                my $saveChanged = $$et{CHANGED};
+                my $dat = $et->WriteDirectory(\%subdirInfo, $subTablePtr);
+                if (defined $dat and length($dat) == $len) {
+                    substr($$dataPt, $off, $len) = $dat;
+                } else {
+                    $$et{CHANGED} = $saveChanged;   # didn't change anything after all
+                }
+            } else {
+                # loop through main tag and flags (don't yet consider flag 2)
+                for ($i=-1; $i<2; ++$i) {
+                    $tagInfo = $$newTags{$i>=0 ? sprintf('0x%x.%d',$tag,$i) : $tag};
+                    next unless $tagInfo;
+                    if ($i >= 0) {
+                        $off = $entry + 8 + 4 * $i;
+                        $format = 'int32u';
+                        $len = 4;
+                        undef $val;
+                    }
+                    $val = ReadValue($dataPt, $off, $format, undef, $len) unless defined $val;
+                    my $nvHash;
+                    my $newVal = $et->GetNewValue($tagInfo, \$nvHash);
+                    if ($et->IsOverwriting($nvHash, $val) and defined $newVal) {
+                        my $count = int($len / Image::ExifTool::FormatSize($format));
+                        my $rtnVal = WriteValue($newVal, $format, $count, $dataPt, $off);
+                        if (defined $rtnVal) {
+                            $et->VerboseValue("- CanonVRD:$$tagInfo{Name}", $val);
+                            $et->VerboseValue("+ CanonVRD:$$tagInfo{Name}", $newVal);
+                            ++$$et{CHANGED};
+                        }
+                    }
+                }
+            }
+            next;
+        }
+        $et->HandleTag($tagTablePtr, $tag, $val,
+            DataPt  => $dataPt,
+            DataPos => $dataPos,
+            Start   => $off,
+            Size    => $len,
+            Index   => $index,
+            Format  => $format,
+            # $flg[0] is on/off flag
+            # $flg[1] "is default" flag?
+            # $flg[2] changed to 0 when some unsharp mask settings were changed
+            Extra   => ", fmt=$fmt flags=" . join(',', @flg),
+        );
+        foreach $i (0..2) {
+            my $flagID = sprintf('0x%x.%d', $tag, $i);
+            $et->HandleTag($tagTablePtr, $flagID, $flg[$i]) if $$tagTablePtr{$flagID};
+        }
+    }
+    return 1 unless $isWriting;
+    return substr($$dataPt, $pos, $dirLen) unless $raf;
+    return 1 if Write($outfile, substr($$dataPt, $pos, $dirLen));
+    return -1;
 }
 
@@ -1071,5 +1898,5 @@
 sub ProcessVRD($$)
 {
-    my ($exifTool, $dirInfo) = @_;
+    my ($et, $dirInfo) = @_;
     my $raf = $$dirInfo{RAF};
     my $buff;
@@ -1077,33 +1904,34 @@
 
     # initialize write directories if necessary
-    $exifTool->InitWriteDirs(\%vrdMap, 'XMP') if $$dirInfo{OutFile};
+    $et->InitWriteDirs(\%vrdMap, 'XMP') if $$dirInfo{OutFile};
 
     if (not $num and $$dirInfo{OutFile}) {
         # create new VRD file from scratch
-        my $newVal = $exifTool->GetNewValues('CanonVRD');
+        my $newVal = $et->GetNewValue('CanonVRD');
         if ($newVal) {
-            $exifTool->VPrint(0, "  Writing CanonVRD as a block\n");
+            $et->VPrint(0, "  Writing CanonVRD as a block\n");
             Write($$dirInfo{OutFile}, $newVal) or return -1;
-            ++$exifTool->{CHANGED};
+            $$et{DidCanonVRD} = 1;
+            ++$$et{CHANGED};
         } else {
             # allow VRD to be created from individual tags
-            if ($$exifTool{ADD_DIRS}{CanonVRD}) {
+            if ($$et{ADD_DIRS}{CanonVRD}) {
                 my $newVal = '';
-                if (ProcessCanonVRD($exifTool, { OutFile => \$newVal }) > 0) {
+                if (ProcessCanonVRD($et, { OutFile => \$newVal }) > 0) {
                     Write($$dirInfo{OutFile}, $newVal) or return -1;
-                    ++$exifTool->{CHANGED};
+                    ++$$et{CHANGED};
                     return 1;
                 }
             }
-            $exifTool->Error('No CanonVRD information to write');
+            $et->Error('No CanonVRD information to write');
         }
     } else {
         $num == 0x1c or return 0;
         $buff =~ /^CANON OPTIONAL DATA\0/ or return 0;
-        $exifTool->SetFileType();
+        $et->SetFileType();
         $$dirInfo{DirName} = 'CanonVRD';    # set directory name for verbose output
-        my $result = ProcessCanonVRD($exifTool, $dirInfo);
+        my $result = ProcessCanonVRD($et, $dirInfo);
         return $result if $result < 0;
-        $result or $exifTool->Warn('Format error in VRD file');
+        $result or $et->Warn('Format error in VRD file');
     }
     return 1;
@@ -1117,101 +1945,176 @@
 sub WriteCanonVRD($$;$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
-    $exifTool or return 1;    # allow dummy access
-    my $nvHash = $exifTool->GetNewValueHash($Image::ExifTool::Extra{CanonVRD});
-    return undef unless Image::ExifTool::IsOverwriting($nvHash);
-    my $val = Image::ExifTool::GetNewValues($nvHash);
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;    # allow dummy access
+    my $nvHash = $et->GetNewValueHash($Image::ExifTool::Extra{CanonVRD});
+    my $val = $et->GetNewValue($nvHash);
     $val = '' unless defined $val;
-    ++$exifTool->{CHANGED};
+    return undef unless $et->IsOverwriting($nvHash, $val);
+    ++$$et{CHANGED};
     return $val;
 }
 
 #------------------------------------------------------------------------------
-# Read/write CanonVRD information
+# Write DR4-type CanonVRD edit record
+# Inputs: 0) ExifTool object ref, 1) dirInfo ref, 2) tag table ref
+# Returns: VRD data block (may be empty if deleted, of undef on error)
+sub WriteCanonDR4($$;$)
+{
+    my ($et, $dirInfo, $tagTablePtr) = @_;
+    $et or return 1;    # allow dummy access
+    my $nvHash = $et->GetNewValueHash($Image::ExifTool::Extra{CanonDR4});
+    my $val = $et->GetNewValue($nvHash);
+    if (defined $val) {
+        return undef unless $et->IsOverwriting($nvHash, $val);
+        $et->VPrint(0, "  Writing CanonDR4 as a block\n");
+        ++$$et{CHANGED};
+        return WrapDR4($val);
+    }
+    my $buff = '';
+    $$dirInfo{OutFile} = \$buff;
+    return $buff if ProcessCanonVRD($et, $dirInfo, $tagTablePtr) > 0;
+    return undef;
+}
+
+#------------------------------------------------------------------------------
+# Read/write CanonVRD information (from VRD file or VRD trailer)
 # Inputs: 0) ExifTool object reference, 1) dirInfo reference
 # Returns: 1 on success, 0 not valid VRD, or -1 error writing
 # - updates DataPos to point to start of CanonVRD information
-# - updates DirLen to trailer length
+# - updates DirLen to existing trailer length
 sub ProcessCanonVRD($$;$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $raf = $$dirInfo{RAF};
     my $offset = $$dirInfo{Offset} || 0;
     my $outfile = $$dirInfo{OutFile};
-    my $verbose = $exifTool->Options('Verbose');
-    my $out = $exifTool->Options('TextOut');
-    my ($buff, $footer, $header, $created, $err);
-    my ($blockLen, $blockType, $size, %didDir);
-
-    if (not $raf) {
-        my $vrdPt = $$dirInfo{DataPt};
-        unless ($vrdPt) {
+    my $dataPt = $$dirInfo{DataPt};
+    my $verbose = $et->Options('Verbose');
+    my $out = $et->Options('TextOut');
+    my ($buff, $created, $err, $blockLen, $blockType, %didDir, $fromFile);
+#
+# The CanonVRD trailer has a 0x1c-byte header and a 0x40-byte footer,
+# each beginning with "CANON OPTIONAL DATA\0" and containing an int32u
+# giving the size of the contained data (at byte 0x18 and 0x14 respectively)
+#
+    if ($raf) {
+        $fromFile = 1;
+    } else {
+        unless ($dataPt) {
             return 1 unless $outfile;
             # create blank VRD data from scratch
-            my $blank = "CANON OPTIONAL DATA\0\0\x01\0\0\0\0\0\0" .
-                        "CANON OPTIONAL DATA\0" . ("\0" x 42) . "\xff\xd9";
-            $vrdPt = \$blank;
-            $verbose and printf $out "  Creating CanonVRD trailer\n";
+            my $blank = $blankHeader . $blankFooter;
+            $dataPt = \$blank;
+            $verbose and print $out "  Creating CanonVRD trailer\n";
             $created = 1;
         }
-        $raf = new File::RandomAccess($vrdPt);
+        $raf = new File::RandomAccess($dataPt);
     }
-    # read and validate the trailer footer
-    $raf->Seek(-64-$offset, 2)    or return 0;
-    $raf->Read($footer, 64) == 64 or return 0;
-    $footer =~ /^CANON OPTIONAL DATA\0(.{4})/s or return 0;
-    $size = unpack('N', $1);
-
-    # read and validate the header too
-    # (header is 0x1c bytes and footer is 0x40 bytes)
-    unless (($size & 0x80000000) == 0 and
-            $raf->Seek(-$size-0x5c, 1) and
-            $raf->Read($header, 0x1c) == 0x1c and
-            $header =~ /^CANON OPTIONAL DATA\0/ and
-            $raf->Read($buff, $size) == $size)
+    # read and validate the footer
+    $raf->Seek(-0x40-$offset, 2)    or return 0;
+    $raf->Read($buff, 0x40) == 0x40 or return 0;
+    $buff =~ /^CANON OPTIONAL DATA\0(.{4})/s or return 0;
+    my $dirLen = unpack('N', $1) + 0x5c;  # size including header+footer
+
+    # read and validate the header
+    unless ($dirLen < 0x80000000 and
+            $raf->Seek(-$dirLen, 1) and
+            $raf->Read($buff, 0x1c) == 0x1c and
+            $buff =~ /^CANON OPTIONAL DATA\0/ and
+            $raf->Seek(-0x1c, 1))
     {
-        $exifTool->Warn('Bad CanonVRD trailer');
+        $et->Warn('Bad CanonVRD trailer');
         return 0;
     }
-    # extract CanonVRD block if Binary option set, or if requested
-    if ($exifTool->{OPTIONS}->{Binary} or $exifTool->{REQ_TAG_LOOKUP}->{canonvrd}) {
-        $exifTool->FoundTag('CanonVRD', $header . $buff . $footer);
+    # set variables returned in dirInfo hash
+    $$dirInfo{DataPos} = $raf->Tell();
+    $$dirInfo{DirLen} = $dirLen;
+
+    if ($outfile and ref $outfile eq 'SCALAR' and not length $$outfile) {
+        # write directly to outfile to avoid duplicating data in memory
+        $$outfile = $$dataPt unless $fromFile;
+        # TRICKY! -- copy to outfile memory buffer and edit in place
+        # (so we must disable all Write() calls for this case)
+        $dataPt = $outfile;
     }
-    # set variables returned in dirInfo hash
-    $$dirInfo{DataPos} = $raf->Tell() - $size - 0x1c;
-    $$dirInfo{DirLen} = $size + 0x5c;
+    if ($fromFile or $$dirInfo{DirStart}) {
+        $dataPt = \$buff unless $dataPt;
+        # read VRD data into memory if necessary
+        unless ($raf->Read($$dataPt, $dirLen) == $dirLen) {
+            $$dataPt = '' if $outfile and $outfile eq $dataPt;
+            $et->Warn('Error reading CanonVRD data');
+            return 0;
+        }
+    }
+    # exit quickly if writing and no CanonVRD tags are being edited
+    if ($outfile and not exists $$et{EDIT_DIRS}{CanonVRD}) {
+        print $out "$$et{INDENT}  [nothing changed]\n" if $verbose;
+        return 1 if $outfile eq $dataPt;
+        return Write($outfile, $$dataPt) ? 1 : -1;
+    }
+
+    my $vrdType = 'VRD';
 
     if ($outfile) {
-        $verbose and not $created and printf $out "  Rewriting CanonVRD trailer\n";
+        $verbose and not $created and print $out "  Rewriting CanonVRD trailer\n";
         # delete CanonVRD information if specified
-        if ($exifTool->{DEL_GROUP}->{CanonVRD} or $exifTool->{DEL_GROUP}->{Trailer} or
-            # also delete if writing as a block (will get added back again later)
-            $exifTool->{NEW_VALUE}->{$Image::ExifTool::Extra{CanonVRD}})
-        {
-            if ($exifTool->{FILE_TYPE} eq 'VRD') {
-                my $newVal = $exifTool->GetNewValues('CanonVRD');
+        my $doDel = $$et{DEL_GROUP}{CanonVRD};
+        unless ($doDel) {
+            $doDel = 1 if $$et{DEL_GROUP}{Trailer} and $$et{FILE_TYPE} ne 'VRD';
+            unless ($doDel) {
+                # also delete if writing as a block (will get added back again later)
+                if ($$et{NEW_VALUE}{$Image::ExifTool::Extra{CanonVRD}}) {
+                    # delete if this isn't version 4
+                    $doDel = 1 unless $$dataPt =~ /^.{28}\xff\xff\0\xf7/s;
+                }
+                if ($$et{NEW_VALUE}{$Image::ExifTool::Extra{CanonDR4}} and not $doDel) {
+                    # delete if this is version 4
+                    $doDel = 1 if $$dataPt =~ /^.{28}\xff\xff\0\xf7/s;
+                }
+            }
+        }
+        if ($doDel) {
+            if ($$et{FILE_TYPE} eq 'VRD') {
+                my $newVal = $et->GetNewValue('CanonVRD');
                 if ($newVal) {
-                    $verbose and printf $out "  Writing CanonVRD as a block\n";
-                    Write($outfile, $newVal) or return -1;
-                    ++$exifTool->{CHANGED};
+                    $verbose and print $out "  Writing CanonVRD as a block\n";
+                    if ($outfile eq $dataPt) {
+                        $$outfile = $newVal;
+                    } else {
+                        Write($outfile, $newVal) or return -1;
+                    }
+                    $$et{DidCanonVRD} = 1;
+                    ++$$et{CHANGED};
                 } else {
-                    $exifTool->Error("Can't delete all CanonVRD information from a VRD file");
+                    $et->Error("Can't delete all CanonVRD information from a VRD file");
                 }
             } else {
-                $verbose and printf $out "  Deleting CanonVRD trailer\n";
-                ++$exifTool->{CHANGED};
+                $verbose and print $out "  Deleting CanonVRD trailer\n";
+                $$outfile = '' if $outfile eq $dataPt;
+                ++$$et{CHANGED};
             }
             return 1;
         }
         # write now and return if CanonVRD was set as a block
-        my $val = $exifTool->GetNewValues('CanonVRD');
+        my $val = $et->GetNewValue('CanonVRD');
+        unless ($val) {
+            $val = $et->GetNewValue('CanonDR4');
+            $vrdType = 'DR4' if $val;
+        }
         if ($val) {
-            $verbose and print $out "  Writing CanonVRD as a block\n";
-            Write($outfile, $val) or return -1;
-            ++$exifTool->{CHANGED};
+            $verbose and print $out "  Writing Canon$vrdType as a block\n";
+            # must wrap DR4 data with the VRD header/footer and edit record
+            $val = WrapDR4($val) if $vrdType eq 'DR4';
+            if ($outfile eq $dataPt) {
+                $$outfile = $val;
+            } else {
+                Write($outfile, $val) or return -1;
+            }
+            $$et{DidCanonVRD} = 1;
+            ++$$et{CHANGED};
             return 1;
         }
-    } elsif ($verbose or $exifTool->{HTML_DUMP}) {
-        $exifTool->DumpTrailer($dirInfo) if $$dirInfo{RAF};
+    } elsif ($verbose or $$et{HTML_DUMP}) {
+        $et->DumpTrailer($dirInfo) if $$dirInfo{RAF};
     }
 
@@ -1219,40 +2122,31 @@
 
     # validate VRD trailer and get position and length of edit record
-    SetByteOrder('MM');
-    my $pos = 0;
-    my $vrdPos = $$dirInfo{DataPos} + length($header);
-    my $dataPt = \$buff;
+    SetByteOrder('MM'); # VRD header/footer is big-endian
+    my $pos = 0x1c;     # start at end of header
 
     # loop through the VRD blocks
     for (;;) {
-        if ($pos + 8 > $size) {
-            last if $pos == $size;
-            $blockLen = $size;  # mark as invalid
+        my $end = $dirLen - 0x40;   # end of last VRD block (and start of footer)
+        if ($pos + 8 > $end) {
+            last if $pos == $end;
+            $blockLen = $end;       # mark as invalid
         } else {
             $blockType = Get32u($dataPt, $pos);
             $blockLen = Get32u($dataPt, $pos + 4);
         }
-        $pos += 8;          # move to start of block
-        if ($pos + $blockLen > $size) {
-            $exifTool->Warn('Possibly corrupt CanonVRD block');
+        $vrdType = 'DR4' if $blockType == 0xffff00f7;
+        $pos += 8;  # move to start of block
+        if ($pos + $blockLen > $end) {
+            $et->Warn('Possibly corrupt CanonVRD block');
             last;
         }
         if ($verbose > 1 and not $outfile) {
             printf $out "  CanonVRD block 0x%.8x ($blockLen bytes at offset 0x%x)\n",
-                $blockType, $pos + $vrdPos;
-            if ($verbose > 2) {
-                my %parms = (
-                    Start  => $pos,
-                    Addr   => $pos + $vrdPos,
-                    Out    => $out,
-                    Prefix => $$exifTool{INDENT},
-                );
-                $parms{MaxLen} = $verbose == 3 ? 96 : 2048 if $verbose < 5;
-                Image::ExifTool::HexDump($dataPt, $blockLen, %parms);
-            }
+                $blockType, $pos + $$dirInfo{DataPos};
+            $et->VerboseDump($dataPt, Len => $blockLen, Start => $pos, Addr => $pos + $$dirInfo{DataPos});
         }
         my $tagInfo = $$tagTablePtr{$blockType};
         unless ($tagInfo) {
-            unless ($exifTool->Options('Unknown')) {
+            unless ($et->Options('Unknown')) {
                 $pos += $blockLen;  # step to next block
                 next;
@@ -1266,5 +2160,5 @@
                 Binary      => 1,
             };
-            Image::ExifTool::AddTagToTable($tagTablePtr, $blockType, $tagInfo);
+            AddTagToTable($tagTablePtr, $blockType, $tagInfo);
         }
         if ($$tagInfo{SubDirectory}) {
@@ -1273,5 +2167,5 @@
                 DataPt   => $dataPt,
                 DataLen  => length $$dataPt,
-                DataPos  => $vrdPos,
+                DataPos  => $$dirInfo{DataPos},
                 DirStart => $pos,
                 DirLen   => $blockLen,
@@ -1283,40 +2177,38 @@
                 # set flag indicating we did this directory
                 $didDir{$$tagInfo{Name}} = 1;
-                my $dat;
-                if ($$exifTool{NEW_VALUE}{$tagInfo}) {
+                my ($dat, $diff);
+                if ($$et{NEW_VALUE}{$tagInfo}) {
                     # write as a block
-                    $exifTool->VPrint(0, "Writing $$tagInfo{Name} as a block\n");
-                    $dat = $exifTool->GetNewValues($tagInfo);
+                    $et->VPrint(0, "Writing $$tagInfo{Name} as a block\n");
+                    $dat = $et->GetNewValue($tagInfo);
                     $dat = '' unless defined $dat;
-                    ++$$exifTool{CHANGED};
+                    ++$$et{CHANGED};
                 } else {
-                    $dat = $exifTool->WriteDirectory(\%subdirInfo, $subTablePtr);
+                    $dat = $et->WriteDirectory(\%subdirInfo, $subTablePtr);
                 }
                 # update data with new directory
                 if (defined $dat) {
-                    my $buf2;
-                    if (length $dat or $$exifTool{FILE_TYPE} !~ /^(CRW|VRD)$/) {
+                    if (length $dat or $$et{FILE_TYPE} !~ /^(CRW|VRD)$/) {
                         # replace with new block (updating the block length word)
-                        $buf2 = substr($$dataPt, 0, $pos - 4) . Set32u(length $dat) . $dat;
+                        substr($$dataPt, $pos-4, $blockLen+4) = Set32u(length $dat) . $dat;
                     } else {
                         # remove block totally (CRW/VRD files only)
-                        $buf2 = substr($$dataPt, 0, $pos - 8);
+                        substr($$dataPt, $pos-8, $blockLen+8) = '';
                     }
-                    my $oldBlockEnd = $pos + $blockLen;
-                    $pos = length $$dataPt; # set to start of next block
-                    $buf2 .= substr($$dataPt, $oldBlockEnd);
-                    undef $$dataPt;         # free the memory
-                    $dataPt = \$buf2;
-                    # update the new VRD length in the header/footer
-                    Set32u(length($buf2), \$header, 0x18);
-                    Set32u(length($buf2), \$footer, 0x14);
-                    next;
+                    # make necessary adjustments if block changes length
+                    if (($diff = length($$dataPt) - $dirLen) != 0) {
+                        $pos += $diff;
+                        $dirLen += $diff;
+                        # update the new VRD length in the header/footer
+                        Set32u($dirLen - 0x5c, $dataPt, 0x18);
+                        Set32u($dirLen - 0x5c, $dataPt, $dirLen - 0x2c);
+                    }
                 }
             } else {
                 # extract as a block if requested
-                $exifTool->ProcessDirectory(\%subdirInfo, $subTablePtr);
+                $et->ProcessDirectory(\%subdirInfo, $subTablePtr);
             }
         } else {
-            $exifTool->HandleTag($tagTablePtr, $blockType, substr($$dataPt, $pos, $blockLen));
+            $et->HandleTag($tagTablePtr, $blockType, substr($$dataPt, $pos, $blockLen));
         }
         $pos += $blockLen;  # step to next block
@@ -1324,22 +2216,29 @@
     if ($outfile) {
         # create XMP block if necessary (CRW/VRD files only)
-        if ($$exifTool{ADD_DIRS}{CanonVRD} and not $didDir{XMP}) {
+        if ($$et{ADD_DIRS}{CanonVRD} and not $didDir{XMP}) {
             my $subTablePtr = GetTagTable('Image::ExifTool::XMP::Main');
-            my $dat = $exifTool->WriteDirectory({ Parent => 'CanonVRD' }, $subTablePtr);
+            my $dat = $et->WriteDirectory({ Parent => 'CanonVRD' }, $subTablePtr);
             if ($dat) {
-                $$dataPt .= Set32u(0xffff00f6) . Set32u(length $dat) . $dat;
+                my $blockLen = length $dat;
+                substr($$dataPt, -0x40, 0) = Set32u(0xffff00f6) . Set32u(length $dat) . $dat;
+                $dirLen = length $$dataPt;
                 # update the new VRD length in the header/footer
-                Set32u(length($$dataPt), \$header, 0x18);
-                Set32u(length($$dataPt), \$footer, 0x14);
+                Set32u($dirLen - 0x5c, $dataPt, 0x18);
+                Set32u($dirLen - 0x5c, $dataPt, $dirLen - 0x2c);
             }
         }
         # write CanonVRD trailer unless it is empty
         if (length $$dataPt) {
-            Write($outfile, $header, $$dataPt, $footer) or $err = 1;
+            Write($outfile, $$dataPt) or $err = 1 unless $outfile eq $dataPt;
         } else {
-            $verbose and printf $out "  Deleting CanonVRD trailer\n";
-        }
+            $verbose and print $out "  Deleting CanonVRD trailer\n";
+        }
+    } elsif ($vrdType eq 'VRD' and (($$et{TAGS_FROM_FILE} and
+        not $$et{EXCL_TAG_LOOKUP}{canonvrd}) or $$et{REQ_TAG_LOOKUP}{canonvrd}))
+    {
+        # extract CanonVRD block if copying tags, or if requested (and not DR4 info)
+        $et->FoundTag('CanonVRD', $buff);
     }
-    undef $$dataPt;
+    undef $buff;
     return $err ? -1 : 1;
 }
@@ -1351,5 +2250,5 @@
 =head1 NAME
 
-Image::ExifTool::CanonVRD - Read/write Canon VRD information
+Image::ExifTool::CanonVRD - Read/write Canon VRD and DR4 information
 
 =head1 SYNOPSIS
@@ -1360,11 +2259,11 @@
 
 This module contains definitions required by Image::ExifTool to read and
-write VRD Recipe Data information as written by the Canon Digital Photo
-Professional software.  This information is written to VRD files, and as a
-trailer in JPEG, CRW, CR2 and TIFF images.
+write VRD and DR4 Recipe Data information as written by the Canon Digital
+Photo Professional software.  This information is written to VRD and DR4
+files, and as a trailer in JPEG, CRW, CR2 and TIFF images.
 
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
